HDU 5072 Coprime (单色三角形+容斥原理)

题目链接:Coprime

题面:

Coprime

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 262144/262144 K (Java/Others)

Total Submission(s): 1181    Accepted Submission(s): 471

Problem Description

There are n people standing in a line. Each of them has a unique id number.

Now the Ragnarok is coming. We should choose 3 people to defend the evil. As a group, the 3 people should be able to communicate. They are able to communicate if and only if their id numbers are pairwise coprime or pairwise not coprime. In other words, if their
id numbers are a, b, c, then they can communicate if and only if [(a, b) = (b, c) = (a, c) = 1] or [(a, b) ≠ 1 and (a, c) ≠ 1 and (b, c) ≠ 1], where (x, y) denotes the greatest common divisor of x and y.

We want to know how many 3-people-groups can be chosen from the n people.

Input

The first line contains an integer T (T ≤ 5), denoting the number of the test cases.

For each test case, the first line contains an integer n(3 ≤ n ≤ 105), denoting the number of people. The next line contains n distinct integers a1, a2, . . . , an(1 ≤ ai ≤ 105) separated by
a single space, where ai stands for the id number of the i-th person.

Output

For each test case, output the answer in a line.

Sample Input

1
5
1 3 9 10 2

Sample Output

4

Source

2014 Asia AnShan Regional Contest

解题:

题意求找出三数互质或都不互质的组数,直接肯定不行。此题原型为单色三角形,结果为C(3,n)-res,其中res为每个与每个数互质和不互质数量的乘积的累加。求与每个数不互质的数量,用到了容斥原理。看似简单的原理应用却这么广泛,如果没做过容斥原理的题目,可以先试一下HDU 1796。

代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <cmath>
using namespace std;
bool status[100010];
int factor[100010][8];
int store[100010],cnt[100010];
long long ans[100010],res;
int one_amount[300];
int refl[300][8];
int cal[8];
void prep()
{
    memset(refl,0,sizeof(refl));
    int cont=0,temp;
   for(int i=0;i<256;i++)
   {
       temp=i;
       one_amount[i]=cont=0;
       while(temp)
       {
         if(temp%2)
         {
             one_amount[i]++;
             refl[i][cont]=1;
         }
         cont++;
         temp/=2;
       }
   }
}
bool is_prime(int a)
{
	if(a<=3)return true;
	int x=sqrt(1.0*a);
	for(int i=2;i<=x;i++)
	{
		if(a%i==0)
			return false;
	}
	return true;
}
long long C(int x,int y)
{
	long long res=1;
	for(int i=1;i<=x;i++)
	{
		res=res*(y-i+1)/i;
	}
	return res;
}
int main()
{
	int t,n,p,tmp;
	long long temp;
	scanf("%d",&t);
	prep();
	while(t--)
	{
		res=0;
		memset(status,0,sizeof(status));
		memset(factor,0,sizeof(factor));
		memset(cnt,0,sizeof(cnt));
		memset(ans,0,sizeof(ans));
		scanf("%d",&n);
		for(int i=0;i<n;i++)
			scanf("%d",&store[i]);
		for(int i=0;i<n;i++)
			status[store[i]]=1;
        for(int i=2;i<=100000;i++)
		{
	       if(is_prime(i))
		   {
			   for(int j=i;j<=100000;j+=i)
			   {
				   if(status[j])
				   {
					   cnt[i]++;
				   }
				   p=0;
				   while(factor[j][p])
				   {
					   p++;
				   }
				   factor[j][p]=i;
			   }
		   }
		   else
		   {
             for(int j=i;j<=100000;j+=i)
			   {
				   if(status[j])
				   {
					   cnt[i]++;
				   }
			   }

		   }
		}
        for(int i=0;i<n;i++)
		{
           tmp=store[i];
           p=0;
		   while(factor[tmp][p])
		   {
			   cal[p]=factor[tmp][p];
			   p++;
		   }
		   if(p==0)
		   {
			   ans[i]=0;
			   continue;
		   }
           tmp=1<<p;
		   for(int j=1;j<tmp;j++)
           {
              temp=1;
              for(int k=0;k<p;k++)
              {
                  if(refl[j][k])
                 {
                    temp=temp*cal[k];
                 }
			   }
              if(one_amount[j]%2)
              ans[i]+=cnt[temp];
              else
              ans[i]-=cnt[temp];
          }
		   ans[i]-=1;
		}
		for(int i=0;i<n;i++)
		{
			res+=(ans[i]*(n-ans[i]-1));
		}
		res/=2;
		printf("%I64d\n",C(3,n)-res);
	}
	return 0;
}

总结:

用好容斥原理的关键在于,搞清楚集合的交的含义。

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-07-29 21:06:23

HDU 5072 Coprime (单色三角形+容斥原理)的相关文章

HDU 5072 Coprime (单色三角形问题+容斥原理)

我们先来介绍一下单色三角形问题,如下 单色三角形 在空间中给出了n个点.这些点任三点不共线,并且每两个点之间都有一条线相连,每一条线不是红的就是黑的.在这些点和线组成的三角形中,如果一个三角形的三条边的颜色都相同,那么我们就称这个三角形为单色三角形.现给出所有涂红色的线,试求出单色三角形的数目. 任务: 请写一个程序: 从文本文件中读入点数和对红色连线的描述: 找出该图中红色三角形的数目: 把结果输出到文件TRO.OUT中. 输入格式: 在文本文件TRO.IN的第一行包括一个整数n,3 <= n

hdu 5072 Coprime(同色三角形+容斥)

pid=5072">http://acm.hdu.edu.cn/showproblem.php?pid=5072 单色三角形模型 现场赛和队友想了3个小时,最后发现想跑偏了.感觉好可惜的一道题,要是知道这个模型....就能够轻松的拿银了啊. . . 题意不再赘述,就是求同色三角形的个数.总的三角形的个数是C(n,3),仅仅需减去不同色的三角形就可以.对于每一个点(数),与它互质的连红边,不互质的连蓝边,那么对于该点不同色三角形个数为蓝边数*红边数/2,由于同一个三角形被计算了两次. 那么同

HDU 5072 Coprime 同色三角形问题

好吧,我承认就算当时再给我五个小时我也做不出来. 首先解释同色三角形问题: 给出n(n >= 3)个点,这些点中的一些被涂上了红色,剩下的被涂上了黑色.然后将这些点两两相连,于是每三个点都会组成一个三角形, 即总共有sum = C(3,n)个三角形.对于一个三角形,如果三个点颜色一样则称其为同色三角形. 那么一个很直观的思路就是容斥,sum - 非同色三角形个数ans. ans = (sigma (Xi*Yi) ) / 2;(1 <= i <= n,Xi,Yi分别表示与第 i 个点相连的

hdu 5072 Coprime(数论)

题目链接:hdu 5072 Coprime 题目大意:给定N个数,问能选出多少个3元组,要么[(a, b) = (b, c) = (a, c) = 1] or [(a, b) ≠ 1 and (a, c) ≠ 1 and (b, c) ≠ 1]. 解题思路:这题可以换个角度想,可以将三个数看做三角形的三条边,互质即边的颜色为1,否则为0,那么要求的即为 三条边颜色相同的三角形有多少个. 总的三角形的个数可求,那么如果求出三条边不完全相同的三角形个数,相减一下即可. 枚举顶点,然后确定以该点形成的

[容斥原理] hdu 5072 Coprime

题意: 给n个数,求这n个数取3个数构成一个集合, 这三个数两两互质或者两两不互质,为有多少种取法. 思路: 首先这可以转换成一个单色三角形的问题. 就是三个数为三角形的三个顶点,两个顶点如果互质则边为1,不互质边为0 为三条边均为1或者均为0的三角形就多少个. 因为三角形的总数我们是知道的,然后我们取对立面算. 那么其实我们可以枚举顶点,然后求出每个数在这些数中和它互质的有多少个,不互质的有多少个 然后各取一个就是我们要的三角形了. 我们假设互质的有X个,不互质的有Y个 那么以Z为顶点的三角形

hdoj 5072 Coprime 【想法+容斥原理】

题目:hdoj 5072 Coprime 题意:给出n个数,然后让你从其中任意选出三个数满足其中三个数都互质或者都不互质,让你求满足这样选择条件的选择种数. 分析:首先我们从反面考虑这个问题,一个满足条件的选择{ a , b , c },题目要求[(a, b) = (b, c) = (a, c) = 1] or [(a, b) ≠ 1 and (a, c) ≠ 1 and (b, c) ≠ 1],其中(a,b)是a和b的最大公约数. 那么其反面就是,[(a, b) = (b, c) =1 and

HDU 5072 Coprime (莫比乌斯反演+容斥+同色三角形)

Coprime Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 262144/262144 K (Java/Others) Total Submission(s): 1469    Accepted Submission(s): 579 Problem Description There are n people standing in a line. Each of them has a unique id number. Now

hdu 5072 Coprime 容斥原理

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 262144/262144 K (Java/Others)Total Submission(s): 1509    Accepted Submission(s): 592 Problem Description There are n people standing in a line. Each of them has a unique id number. Now the Ragn

ACM学习历程—HDU 5072 Coprime(容斥原理)

Description There are n people standing in a line. Each of them has a unique id number. Now the Ragnarok is coming. We should choose 3 people to defend the evil. As a group, the 3 people should be able to communicate. They are able to communicate if